#include "stdAfx.h"
#include "tr3.h"
UINT iWaitTime = 0;
BOOL          bTestingWithWebshots = FALSE;
BOOL          bKillAgentAndACDSee = FALSE;
BOOL          bQuiet = FALSE;
BOOL          bStop = FALSE;
void ParseCommandLine(char *lpParms)
{
    LPSTR         lpArgv[8];
    LPVOID        oldPtr;
    int           a;
    char          *s = lpParms;
    //char          szWaitParm[70] = "";

    for (a = 0; a < 8; a++)
    {
        lpArgv[a] = strtok(s, " ");
        s = 0;
    } 
    for (a = 0; a < 8 && lpArgv[a] && !bStop; a++)
    {
        if (!strcmp(lpArgv[a], "-stop"))
        {
            if (hDialog)
            {
                SendMessage(hDialog, WM_CLOSE, 0, 0);
            } 
            bStop = true;
        } 
        else
            if (!strcmp(lpArgv[a], "-test"))
                bEnableTestMode = true;
            else
                if (!strcmp(lpArgv[a], "-webshots"))
                    bTestingWithWebshots = true;
                else
                    if (!strcmp(lpArgv[a], "-save"))
                    {
                        if ((oldPtr = pICNData) || SetHook(TRUE))
                        {
                            pICNData = (PICNDATA)LocateSharedData();
                            GetICSettings(&icSettings, FALSE, FALSE); // Get settings from registry
                            InitializeCriticalSection(&crObject);
                            SaveIcons(0, FALSE);
                            if (!oldPtr)
                                SetHook(FALSE);
                            bStop = true;
                        } 
                    } 
                    else
                        if (!strcmp(lpArgv[a], "-restore"))
                        {
                            if ((oldPtr = pICNData) || SetHook(TRUE))
                            {
                                pICNData = (PICNDATA)LocateSharedData();
                                GetICSettings(&icSettings, FALSE, FALSE); // Get settings from registry
                                pICNData->icnFgColor = (COLORREF)SendMessage(hListView, LVM_GETTEXTCOLOR, 0, 0);
                                pICNData->icnBkColor = (COLORREF)SendMessage(hListView, LVM_GETTEXTBKCOLOR, 0, 0);
                                InitializeCriticalSection(&crObject);
                                RestoreIcons(0);
                                if (!oldPtr)
                                    SetHook(FALSE);
                                Sleep(100);
                                ShowWindow(hListView, SW_SHOW);
                                UpdateWindow(hListView);
                                bStop = true;
                            } 
                        } 
                        else
                            if ((!strcmp(lpArgv[a], "-quiet")) || (!strcmp(lpArgv[a], "-q")))
                                bQuiet = true;
                            else
                                if (!strcmp(lpArgv[a], "-kill"))
                                    bKillAgentAndACDSee = true;
                                else
                                    if (!strcmp(lpArgv[a], "-wait"))
                                    {
                                        if (a < 7 && lpArgv[a+1])
                                            iWaitTime = 1000*atoi(lpArgv[a+1]);
                                        a++;               // skip operand
                                    } 
                                    else
                                        if (lpArgv[a][0])
                                        {
                                            CHAR          msg[1000];
                                            CHAR          msg2[1000];
          
                                            strcpy(msg,    //
                                                "Iconoid was started with an invalid command line switch (%s)." //
                                                "\nValid command line switches are:" //
                                                "\n\n\t-save      Save icon positions (*)" //
                                                "\n\t-restore   Restore icon positions (*)" //
//                                              "\n\t-wait xx   Delay start until xx seconds after reboot" //
                                                "\n\t-stop      Stop Iconoid if it is running" //
                                                "\n\t-quiet     Suppress some error dialog windows (not recommended)" //
                                                "\n\t-test      Enable test tab" //
                                                "\n\t-webshots  Test using WebShots program (**)" //
                                                "\n\n\n      *\tWhether positions used are for the current resolution" //
                                                "\n\tor for all resolutions depends on the selection made" //
                                                "\n\ton the \"Positions\" tab within Iconoid." //
                                                "\n\n      **\tIntended for testing only" //
                                                "\n\tWebshots is a great program available from" //
                                                "\n\t\thttp://www.webshots.com" //
                                                "\n\tand is not affiliated with SillySot Software in any way.");
                                            wsprintf(msg2, msg, lpArgv[a]);
                                            MessageBox(0, msg2, "Iconoid", 0);
                                            bStop = TRUE;
                                        } 

    } 
} 

void CheckAutoStart(void)
{
    ULONG         dwDataSize;
    HKEY          hKey;
    TCHAR         szKeyName[] = "Software\\Microsoft\\Windows\\CurrentVersion\\Run";
    TCHAR         szValue[] = "Settings";
    DWORD         dwType = REG_BINARY;
    ICSETTINGS    icDataRet;

    hKey = 0;
    icDataRet.size = 0;
    RegOpenKeyEx(HKEY_CURRENT_USER, szKeyName, NULL, KEY_ALL_ACCESS, &hKey);
    if (hKey)
    {
        if (ERROR_SUCCESS == RegQueryValueEx(hKey, szValue, NULL, &dwType, NULL, &dwDataSize))
        {
            icSettings.bAutoStart = true;
        } 
        RegCloseKey(hKey);
    } 
} 

void SetAutoStart(BOOL bAdd)
{
    DWORD         dwDataSize;
    HKEY          hKey;
    DWORD         disposition;
    TCHAR         szFileName[MAX_PATH];
    TCHAR         szKeyFileName[MAX_PATH];
    TCHAR         szKeyName[] = "Software\\Microsoft\\Windows\\CurrentVersion\\Run";
    //char          szWaitParm[70] = "";

    GetModuleFileName(hInst, szFileName, MAX_PATH);
    strcpy(szKeyFileName, "\"");
    strcat(szKeyFileName, szFileName);
    strcat(szKeyFileName, "\"");
//    wsprintf(szWaitParm, " -wait %d", iWaitTime/1000);
//    strcat(szKeyFileName, szWaitParm);
    if (bQuiet)
        strcat(szKeyFileName, " -q");
    if (bEnableTestMode)
        strcat(szKeyFileName, " -test");

    SECURITY_ATTRIBUTES secattr;                           // security parm for regcreatekeyex

    dwDataSize = (DWORD)strlen(szKeyFileName);
    secattr.nLength = sizeof secattr;
    secattr.lpSecurityDescriptor = NULL;
    secattr.bInheritHandle = TRUE;
    if (ERROR_SUCCESS == RegCreateKeyEx(HKEY_CURRENT_USER, szKeyName, 0, "", 0, KEY_ALL_ACCESS, &secattr, &hKey, &disposition))
        if (hKey)
        {
            if (bAdd)
            {
                if (RegSetValueEx(hKey, "Iconoid", NULL, REG_SZ, (BYTE *)szKeyFileName, dwDataSize))
                    RegDeleteValue(hKey, "Iconoid");
            } 
            else
                RegDeleteValue(hKey, "Iconoid");
            RegCloseKey(hKey);
        } 
} 

